"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var keycode_1 = require("./keycode");
var keycode = require('keycode');
;
;
var KeycodeComponent = (function (_super) {
    __extends(KeycodeComponent, _super);
    function KeycodeComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.handleKeyDown = function (e) {
            var keyboardInput = _this.props.keyboardInput;
            var keyCode = e.keyCode;
            e.preventDefault();
            if (!keycode(keyCode)) {
                _this.props.onChange('invalid');
            }
            else if (keyboardInput.indexOf(keyCode) === -1) {
                console.log(keyCode);
                var newKeyboardInput = void 0;
                if (keycode_1.specialChar.includes(keyCode)) {
                    newKeyboardInput = [keyCode].concat(keyboardInput);
                }
                else {
                    newKeyboardInput = keyboardInput.concat([keyCode]);
                }
                _this.props.onChange(newKeyboardInput);
            }
        };
        return _this;
    }
    KeycodeComponent.prototype.render = function () {
        var keyboardInput = this.props.keyboardInput;
        var val = keyboardInput.map(function (val) { return keycode_1.keycodeToName(val); }).join('+');
        return (React.createElement("div", { className: "react-keycode-wrapper" },
            React.createElement("input", { type: "text", className: "react-keycode-input", value: val, onKeyDown: this.handleKeyDown })));
    };
    KeycodeComponent.defaultProps = {
        keyboardInput: []
    };
    return KeycodeComponent;
}(React.Component));
exports.default = KeycodeComponent;
//# sourceMappingURL=index.js.map